/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_file.h"
#include  <string.h>
#include  <ctype.h>




//------------------------------------
// t@CPsǂݎ
// it@C̏I[̂Ƃ false Ԃj
//------------------------------------
bool
read_one_line(FILE* fp, char* buf, int max_len)
{
	char *p;

	do {
		p = fgets(buf, max_len, fp);
		if (p==NULL)  return  false;
	} while (buf[0] == '%');				// Rgs̓XLbv

	int i = strlen(p);
	if (i>0 && p[i-1]=='\n') i--;
	for (; i<max_len-1; i++) {
		p[i] = ' ';
	}
	p[max_len - 1] = '\0';

	return true;
}


//--------------------------------------------------------------
//  buf  idx1  idx2 ̊Ԃ̋󔒂 buf2 Ɏo
//  ׂċ󔒂̎ false Ԃ
//--------------------------------------------------------------
bool
extract_string(const char* buf, int idx1, int idx2, char* buf2)
{
	for (;idx1<=idx2; idx1++) {
		if (isspace( int((unsigned char)buf[idx1]) ) == 0) break;
	}
	if (idx1 > idx2) {
		buf2[0] = '\0';
		return  false;
	}

	for (;idx2>idx1; idx2--) {
		if (isspace( int((unsigned char)buf[idx2]) ) == 0) break;
	}

	for (int i=0; i<=idx2-idx1; i++) {
		buf2[i] = buf[idx1+i];
	}

	buf2[idx2-idx1+1] = '\0';
	return  true;
}


bool
is_blank(const char* buf, int idx1, int idx2, char* buf2)
{
	const int imax = idx2 - idx1;
	bool flg = true;

	int i;
	for (i=0; i<=imax; i++) {
		const int idx = idx1+i;
		if (buf[idx]=='\0') break;

		buf2[i] = buf[idx]; 
		if (buf[idx]!=' ')  flg = false;
	}
	buf2[i] = '\0';

	return  flg;
}
